
ParticleDefinitions[GaugeES] = {

      {SdL,  {                  PDG ->  {0,0,0},
                Width -> {0, 0, 0},
                Mass -> Automatic,   
                LaTeX -> "\\tilde{d}",
                FeynArtsNr -> 14,
                OutputName -> "dL" }},              
              
      {SdR,  {                PDG -> {0, 0, 0},
               Width -> {0, 0, 0}, 
               Mass -> Automatic,
               FeynArtsNr -> 15,
               LaTeX -> "\\tilde{d}^c",
               OutputName -> "dR" }},
               
       {SuL,  {                PDG -> {0, 0, 0},
               Width -> {0, 0, 0}, 
               Mass -> Automatic,
               FeynArtsNr -> 16,
               LaTeX -> "\\tilde{u}",
               OutputName -> "uL" }}, 
               
       {SuR,  {                PDG -> {0, 0, 0},
               Width -> {0, 0, 0}, 
               Mass -> Automatic,
               FeynArtsNr -> 17,
               LaTeX -> "\\tilde{u}^c",
               OutputName -> "uR" }},
      
       {SeL,  {                PDG -> {0, 0, 0},
               Width -> {0, 0, 0}, 
               Mass -> Automatic,
               FeynArtsNr -> 12,
               LaTeX -> "\\tilde{e}",
               OutputName -> "eL" }}, 
               
       {SeR,  {                PDG -> {0, 0, 0},
               Width -> {0, 0, 0}, 
               Mass -> Automatic,
               FeynArtsNr -> 13,
               LaTeX -> "\\tilde{e}^c",
               OutputName -> "eR" }},
     
       {SvL,  {                PDG -> {0, 0, 0},
               Width -> {0, 0, 0}, 
               Mass -> Automatic,
               FeynArtsNr -> 10,
               LaTeX -> "\\tilde{\\nu}",
               OutputName -> "nL" }},

       {SvR,  {                PDG -> {0, 0, 0},
               Width -> {0, 0, 0}, 
               Mass -> Automatic,
               LaTeX -> "\\tilde{\\nu}^c",
               OutputName -> "nR" }},
      
      {SHd0,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 1,
                 LaTeX -> "H_d^0",
                 OutputName -> "Hd0" }},
      
      {SHdm,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 2,
                 LaTeX -> "H_d^-",
                 OutputName -> "Hdm" }}, 
                 
      {SHu0,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 3,
                 LaTeX -> "H_u^0",
                 OutputName -> "Hu0" }},
      
      {SHup,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 4,
                 LaTeX -> "H_u^+",
                 OutputName -> "Hup" }},      
     
      {VB,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 1,
                 LaTeX -> "B",
                 OutputName -> "B" }},
    
      {VG,    {                  PDG -> 21,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 5,
                 LaTeX -> "G",
                 OutputName -> "G" }},
     
      {VWL,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 2,
                 LaTeX -> "W_L",
                 OutputName -> "WL" }},

      {VWR,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "W_R",
                 OutputName -> "WR" }},
     
      {gB,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 1,
                 LaTeX -> "\\eta^B",
                 OutputName -> "gB" }},
    
      {gG,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 5,
                 LaTeX -> "\\eta^G",
                 OutputName -> "gG" }},
     
      {gWL,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 2,
                 LaTeX -> "\\eta^{W_L}",
                 OutputName -> "gWL" }},

      {gWR,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\eta^{W_R}",
                 OutputName -> "gWR" }},    
                 
      {Fd,    {                  PDG -> {1,3,5},
                 Width -> {0, 0, 0}, 
                 Mass -> Automatic,
                 FeynArtsNr -> 4,
                 LaTeX -> "d",
                 OutputName -> "d" }},   
                 
      {Fu,    {                  PDG -> {2,4,6},
                 Width -> {0, 0, 0}, 
                 Mass -> Automatic,
                 FeynArtsNr -> 3,
                 LaTeX -> "u",
                 OutputName -> "u" }},   
                 
      {Fe,    {                  PDG -> {11,13,15},
                 Width -> {0, 0, 0}, 
                 Mass -> Automatic,
                 FeynArtsNr -> 2,
                 LaTeX -> "e",
                 OutputName -> "e" }},
                 
      {Fv,    {                  PDG -> {12,14,16},
                 Width -> {0, 0, 0}, 
                 Mass -> Automatic,
                 FeynArtsNr -> 1,
                 LaTeX -> "\\nu",
                 OutputName -> "n" }},                                                                                      
      {Glu,    {                  PDG -> 100039,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 15,
                 LaTeX -> "\\tilde{g}",
                 OutputName -> "g" }},
                 
      {Wino,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 12,
                 LaTeX -> "\\tilde{W}",
                 OutputName -> "w" }},
                 
      {Bino,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 11,
                 LaTeX -> "\\tilde{B}",
                 OutputName -> "b" }},              
     
      {HD0,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 21,
                 LaTeX -> "\\tilde{H_d^0}",
                 OutputName -> "HD0" }},
        
      {HU0,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 22,
                 LaTeX -> "\\tilde{H_u^0}",
                 OutputName -> "HU0" }},
        
      {HDm,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 23,
                 LaTeX -> "\\tilde{H_d^-}",
                 OutputName -> "HDM" }},
        
      {HUp,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 FeynArtsNr -> 24,
                 LaTeX -> "\\tilde{H_u^+}",
                 OutputName -> "HUP" }},

      {SdeltaL,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Delta",
                 OutputName -> "DeltaL" }},

      {SdeltaLbar,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\overline{\\Delta}",
                 OutputName -> "DeltaLbar" }},

      {SdeltaR,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Delta^c",
                 OutputName -> "DeltaR" }},

      {SdeltaRbar,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\overline{\\Delta}^c",
                 OutputName -> "DeltaRbar" }},

      {FdeltaL,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Delta}",
                 OutputName -> "FDeltaL" }},

      {FdeltaLbar,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\overline{\\Delta}}^c",
                 OutputName -> "FDeltaLbar" }},

      {FdeltaR,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Delta}^c",
                 OutputName -> "FDeltaR" }},

      {FdeltaRbar,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\overline{\\Delta}}^c",
		 OutputName -> "FDeltaRbar" }},

      {SomegaL,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Omega",
                 OutputName -> "OmegaL" }},

      {SomegaR,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Omega^c",
                 OutputName -> "OmegaR" }},

      {FomegaL,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Omega}",
                 OutputName -> "FOmegaL" }},

      {FomegaR,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Omega}^c",
                 OutputName -> "FOmegaR" }}
      };

      
  ParticleDefinitions[EWSB] = {

   {SomegaL0,     {  LaTeX -> "\\tilde{\\Omega}^0",
                 OutputName -> "SOL0" }},

   {hhR1,     {  LaTeX -> "h",
                 OutputName -> "hhR1" }},

   {AhR1,     {  LaTeX -> "A^0",
                 OutputName -> "AhR1" }},
    
    
      
     {Hpm,     {  LaTeX -> "H^\\pm",
                 OutputName -> "Hp" }},

      {VBY,    { LaTeX -> "B_Y",
                 OutputName -> "BY" }},
    
      {VG,    {   LaTeX -> "G",
                 OutputName -> "G" }},
     
      {VWL,    {   LaTeX -> "W_L",
                 OutputName -> "WL" }},
     
      {VWRm,   {  Mass -> Automatic,
                 Goldstone -> Hpm1R1[{1}],
                 LaTeX -> "W_R^-",
                 OutputName -> "WRm" }},

      {VZ2,   {  LaTeX -> "Z_2",
                 Goldstone -> AhR1[{1}],
                 OutputName -> "VZ2" }},

      {gBY,    { 
                 LaTeX -> "\\eta^Y",
                 OutputName -> "gBY" }},
    
      {gG,    {  LaTeX -> "\\eta^G",
                 OutputName -> "gG" }},
     
      {gWL,    {   LaTeX -> "\\eta^{W_L}",
                 OutputName -> "gWL" }},

      {gWRm,    { LaTeX -> "\\eta_R^-",
                 OutputName -> "gWRm" }}, 
                 
      {gWRmC,    {  LaTeX -> "\\eta_R^+",
                 OutputName -> "gWRC" }},

      {gVZ2,    {  LaTeX -> "\\eta_Z",
                 OutputName -> "gVZ2" }},   

     
      {GluR1,    {
                 LaTeX -> "\\tilde{g}",
                 OutputName -> "g" }},

      {WinoLr1,    {
                 LaTeX -> "\\tilde{w}",
                 OutputName -> "w" }},

      {BinoR1,    {                LaTeX -> "\\tilde{b}",
                 OutputName -> "b" }},

      {Fd1r1,    {
                 LaTeX -> "d_L",
                 OutputName -> "Fd1" }},

      {Fd2r1,    {
                 LaTeX -> "d_R",
                 OutputName -> "Fd2" }},

      {Fu1r1,    {
                 LaTeX -> "u_L",
                 OutputName -> "Fu1" }},

      {Fu2r1,    {
                 LaTeX -> "u_R",
                 OutputName -> "Fu2" }},

      {Fe1r1,    {
                 LaTeX -> "e_L",
                 OutputName -> "Fe1" }},

      {Fe2r1,    {
                 LaTeX -> "e_R",
                 OutputName -> "Fe2" }},
                 
      {ChiR1,    {
                 LaTeX -> "\\tilde{\\chi}^0",
                 OutputName -> "C0" }},
                 
      {Cha1r1,    {
                 LaTeX -> "\\chi^{\\pm}",
                 OutputName -> "CA" }},

      {FvR1,    {
                 LaTeX -> "\\nu",
                 OutputName -> "nu" }},

      {H0r1,    {
                 LaTeX -> "H^0",
                 OutputName -> "H0" }},

      {HCr1,    {
                 LaTeX -> "H^-",
                 OutputName -> "HC" }},

      {Om1r1,    {
                 LaTeX -> "\\Omega_L^0",
                 OutputName -> "OL0" }},


      {Om2r1,    {
                 LaTeX -> "\\Omega_L^-",
                 OutputName -> "OLm" }},


      {DL1r1,    {
                 LaTeX -> "\\Delta_L^+",
                 OutputName -> "DLp" }},

      {DL2r1,    {
                 LaTeX -> "\\Delta_L^{++}",
                 OutputName -> "DLpp" }},

      {DL3r1,    {
                 LaTeX -> "\\Delta_L^0",
                 OutputName -> "DL0" }},


      {DR1r1,    {
                 LaTeX -> "\\Delta_R^0",
                 OutputName -> "R0" }},

      {DR2r1,    {
                 LaTeX -> "\\Delta_R^{-}",
                 OutputName -> "DRm" }},

      {DR3r1,    {
                 LaTeX -> "\\Delta_R^{--}",
                 OutputName -> "DRmm" }},


       {Hpm1R1, {LaTeX -> "\\delta^{c-}",
                 OutputName ->"Hpm1"}},
       {Hpm2R1, {LaTeX -> "\\omega^{c-}",
                 OutputName ->"Hpm2"}},
       
       
          {SDLr1, {LaTeX -> "\\tilde{D}_L",
                 OutputName ->"SDL"}},
    {SULr1, {LaTeX -> "\\tilde{U}_L",
                 OutputName ->"SUL"}},
    {SDRr1, {LaTeX -> "\\tilde{D}_R",
                 OutputName ->"SDR"}},
    {SURr1, {LaTeX -> "\\tilde{U}_R",
                 OutputName ->"SUR"}},
    {SELr1, {LaTeX -> "\\tilde{E}_L",
                 OutputName ->"SEL"}},
    {SERr1, {LaTeX -> "\\tilde{E}_R",
                 OutputName ->"SER"}},
    {SVLr1, {LaTeX -> "\\tilde{V}_L",
                 OutputName ->"SVL"}},
    {SVRr1, {LaTeX -> "\\tilde{V}_R",
                 OutputName ->"SVR"}},
    {SH0r1, {LaTeX -> "H",
                 OutputName ->"H"}},
    {SHCr1, {LaTeX -> "H^-",
                 OutputName ->"HC"}},
    {SO1r1, {LaTeX -> "\\omega",
                 OutputName ->"Om"}},
    {SDLpR1, {LaTeX -> "\\delta^+",
                 OutputName ->"SDLp"}},
    {SDL0r1, {LaTeX -> "\\delta^0",
                 OutputName ->"SDL0"}},
    {SDLppR1, {LaTeX -> "\\delta^{++}",
                 OutputName ->"SDLpp"}},
    {SDRmmR1, {LaTeX -> "\\delta^{c --}",
                 OutputName ->"SDRmm"}},
    {SDR0r1, {LaTeX -> "\\delta^{c 0}",
                 OutputName ->"SDR0"}}
       
        };    
        
        
        
 WeylFermionAndIndermediate = {
       {FHd0,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{H}_d^0",
                 OutputName -> "" }},      
                 
       {FHu0,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{H}_u^0",
                 OutputName -> "" }}, 
                 
       {FHdm,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{H}_d^-",
                 OutputName -> "" }},                             
   
       {FHup,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{H}_u^+",
                 OutputName -> "" }},

       {FvL,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\nu_L",
                 OutputName -> "" }},                             
   
       {FvR,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\nu_R",
                 OutputName -> "" }},

   {FomegaLm,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Omega}^-",
                 OutputName -> "" }},


   {FomegaRm,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Omega}^{c -}",
                 OutputName -> "" }},

   {FdeltaRm,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Delta}^{c-}",
                 OutputName -> "" }},                             
   
{FdeltaLbarm,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\overline{\\Delta}}^-",
                 OutputName -> "" }},

{FdeltaRbarp,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\overline{\\Delta}}^{c +}",
                 OutputName -> "" }},                             
   
   {FdeltaLp,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Delta}^+",
                 OutputName -> "" }},

  {FomegaL0,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Omega}^0",
                 OutputName -> "FOmegaL0" }},

  {FomegaR0,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Omega}^{c 0}",
                 OutputName -> "FOmegaR0" }},

  {FdeltaR0,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Delta}^{c 0}",
                 OutputName -> "" }},                             
   
{FdeltaLbar0,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\overline{\\Delta}}^0",
                 OutputName -> "" }},

{FdeltaRbar0,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\overline{\\Delta}}^{c 0}",
                 OutputName -> "" }},                             
   
   {FdeltaL0,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Delta}^0",
                 OutputName -> "" }},

        {N0,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\lambda_{\\nu}^0",
                 OutputName -> "" }},
                 
        {L0,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\lambda^0",
                 OutputName -> "" }},
                 
        {Lm,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\lambda^-",
                 OutputName -> "" }},
                 
       {Lp,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\lambda^+",
                 OutputName -> "" }},
                 
       {fG,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{G}",
                 OutputName -> "" }},
                 
       {fWL,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{W}_L",
                 OutputName -> "" }},

       {fWR,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{W}_R",
                 OutputName -> "" }},

       {fWL0,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{W}_L^0",
                 OutputName -> "" }},

       {fWR0,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{W}_R^0",
                 OutputName -> "" }},
                 
       {fWRm,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{W}_R^-",
                 OutputName -> "" }},
                 
       {fWRp,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{W}_R^+",
                 OutputName -> "" }},
                 
       {fB,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{B}",
                 OutputName -> "" }},    
                 
       {phid,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\phi_{d}",
                 OutputName -> "" }},

       {phiu,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\phi_{u}",
                 OutputName -> "" }},

       {phiR,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\phi^c",
                 OutputName -> "" }},

       {phiL,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\phi",
                 OutputName -> "" }},

    {phiRbar,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\overline{\\phi}^c",
                 OutputName -> "" }},

    {phiLbar,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\overline{\\phi}",
                 OutputName -> "" }},

    {phiOmL,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\phi_{\\Omega}",
                 OutputName -> "" }},

    {phiOmR,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\phi^c_{\\Omega}",
                 OutputName -> "" }},

    {sigmad,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\sigma_{d}",
                 OutputName -> "" }},                                                                                        
    {sigmau,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\sigma_{u}",
                 OutputName -> "" }},

    {sigmaR,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\sigma^c",
                 OutputName -> "" }},

    {sigmaL,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\sigma",
                 OutputName -> "" }},

 {sigmaRbar,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\overline{\\sigma}^c",
                 OutputName -> "" }},

 {sigmaLbar,   {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\overline{\\sigma}",
                 OutputName -> "" }},

 {sigmaOmL,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\sigma_{\\Omega}",
                 OutputName -> "" }},

 {sigmaOmR,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\sigma_{\\Omega^c}",
                 OutputName -> "" }},

   {SdeltaLp,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Delta^+",
                 OutputName -> "DeltaLp" }},

   {SdeltaL0,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Delta^0",
                 OutputName -> "DeltaL0" }},

  {SdeltaLbarm,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> {"\\overline{\\Delta}^-","\\overline{\\Delta}^+"},
                 OutputName -> "DeltaLbarm" }},

  {SdeltaLbar0,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\overline{\\Delta}^0",
                 OutputName -> "DeltaLbar0" }},

     {SdeltaRm,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> {"\\Delta^{c -}","\\Delta^{c +}"} ,
                 OutputName -> "DeltaRm" }},

     {SdeltaR0,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Delta^{c 0}",
                 OutputName -> "DeltaR0" }},

  {SdeltaRbarp,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> {"\\overline{\\Delta}^{c +}","\\overline{\\Delta}^{c -}"},
                 OutputName -> "DeltaRbarp" }},

  {SdeltaRbar0,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\overline{\\Delta}^{c 0}",
                 OutputName -> "DeltaRbar0" }},

   {SdeltaLpp,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> {"\\Delta^{++}","\\Delta^{--}"},
                 OutputName -> "DeltaLpp" }},

 {SdeltaLbarmm,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> {"\\overline{\\Delta}^{--}","\\overline{\\Delta}^{++}"},
                 OutputName -> "DeltaLbarmm" }},

    {SdeltaRmm,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> {"\\Delta^{c --}","\\Delta^{c ++}"},
                 OutputName -> "DeltaRmm" }},

 {SdeltaRbarpp,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> {"\\overline{\\Delta}^{c ++}","\\overline{\\Delta}^{c --}"},
                 OutputName -> "DeltaRbarpp" }},

 {SomegaLm,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> {"\\Omega^{-}","\\Omega^{+}"},
                 OutputName -> "OmegaLm" }},

 {SomegaLp,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> {"\\Omega^{+}","\\Omega^{-}"},
                 OutputName -> "OmegaLp" }},

 {SomegaL0,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Omega^{0}",
                 OutputName -> "OmegaL0" }},

 {SomegaRm,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Omega^{c -}",
                 OutputName -> "OmegaRm" }},

 {SomegaRp,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Omega^{c +}",
                 OutputName -> "OmegaRp" }},

 {SomegaR0,    {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\Omega^{c 0}",
                 OutputName -> "OmegaR0" }},

  {FdeltaLpp,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Delta}^{++}",
                 OutputName -> "FDeltaLpp" }},

 {FdeltaLbarmm,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\overline{\\Delta}}^{--}",
                 OutputName -> "FDeltaLbarmm" }},

    {FdeltaRmm,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Delta}^{c --}",
                 OutputName -> "FDeltaRmm" }},

 {FdeltaRbarpp,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\overline{\\Delta}}^{c ++}",
                 OutputName -> "FDeltaRbarpp" }},

  {FomegaLm,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Omega}^{-}",
                 OutputName -> "FOmegaLm" }},

  {FomegaLp,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Omega}^{+}",
                 OutputName -> "FOmegaLp" }},

  {FomegaRm,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Omega}^{c -}",
                 OutputName -> "FOmegaRm" }},

  {FomegaRp,  {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{\\Omega}^{c +}",
                 OutputName -> "FOmegaRp" }},

    {SHd,      {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "H_d",
                 OutputName -> "" }},
                                                                            
   {SHu,      {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "H_u",
                 OutputName -> "" }},
      
   {Sl,      {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{L}",
                 OutputName -> "" }},

   {Sq,      {                  PDG -> 0,
                 Width -> 0, 
                 Mass -> Automatic,
                 LaTeX -> "\\tilde{Q}",
                 OutputName -> "" }},
                 
       {e,    { Description -> "Right Electron Superfield" }},
       {d,    { Description -> "Right Down-Quark Superfield" }},                 
       {q,    { Description -> "Left Quark Superfield" }},                 
       {u,    { Description -> "Right Up-Quark Superfield" }},                 
       {l,    { Description -> "left Lepton Superfield" }},  
       {Hd,   { Description -> "Down-Higgs Superfield"}},                                         
       {Hu,   { Description -> "Up-Higgs Superfield" }},                 
       {G,    { Description -> "Gluon Superfield" }},                 
       {B,    { Description -> "B Superfield" }},                 
       {WB,   { Description -> "W Superfield" }},
       {deltaR0, {LaTeX -> "\\hat{\\Delta}^{c 0}"}},
       {deltaRbar0, {LaTeX -> "\\hat{\\bar{\\Delta}}^{c 0}"}},
       {omegaR0, {LaTeX -> "\\hat{\\Omega}^{c 0}"}},
       {omegaL, {LaTeX -> "\\hat{\\Omega}"}},
       {FomegaR0, {LaTeX -> "\\Omega^{c 0}"}},
       {FomegaL, {LaTeX -> "\\Omega"}},
       {SomegaR0, {LaTeX -> "\\tilde{\\Omega}^{c 0}"}},
       {SomegaL, {LaTeX -> "\\tilde{\\Omega}"}},
       {Sl,   { Description -> "Left Slepton" }},
       {Sq,   { Description -> "Left Squark" }},
       {FHd,  { Description -> "Down-Higgsino" }},
       {FHu,  { Description -> "Up-Higgsino" }},
       {Fl,   { Description -> "Left Leptons"}},
       {Fq,   { Description -> "Left Quarks"}}, 
       {WL, {LaTeX -> "\\hat{W}_L"}},
       {WR, {LaTeX -> "\\hat{W}_R"}},
       {fWL, {LaTeX -> "\\tilde{W}_L"}},
       {fWR, {LaTeX -> "\\tilde{W}_R"}},
       {VWR, {LaTeX -> "W_R"}},
       {VWL, {LaTeX -> "W_L"}},
              {fWB,  { Description ->"Wino Weyl-Spinor"}},
       {fW0,  { Description ->"Neutral Wino" }},
       {fWm,  { Description ->"Negative Wino"}},                 
       {fWp,  { Description ->"Positive Wino"}},                 
       {fB,   { Description ->"Bino Weyl-Spinor"}},
       {qL, {LaTeX -> "\\hat{Q}"}},                   
       {qR, {LaTeX -> "\\hat{Q}^c"}},
       {lL, {LaTeX -> "\\hat{L}"}},
       {lR, {LaTeX -> "\\hat{L}^c"}},
       {Phi, {LaTeX -> "\\hat{\\Phi}"}},
       {deltaL, {LaTeX -> "\\hat{\\Delta}"}},
       {deltaLbar, {LaTeX -> "\\hat{\\bar{\\Delta}}"}},
       {deltaR, {LaTeX -> "\\hat{\\Delta}^c"}},
       {deltaRbar, {LaTeX -> "\\hat{\\bar{\\Delta}}^c"}},
        {omegaL, {LaTeX -> "\\hat{\\Omega}"}},
        {omegaR, {LaTeX -> "\\hat{\\Omega}^c"}},
       {SqL, {LaTeX -> "\\hat{Q}"}},                   
       {SqR, {LaTeX -> "\\tilde{Q}^c"}},
       {SlL, {LaTeX -> "\\tilde{L}"}},
       {SlR, {LaTeX -> "\\tilde{L}^c"}},
       {SPhi, {LaTeX -> "\\tilde{\\Phi}"}},
       {FqL, {LaTeX -> "Q"}},                   
       {FqR, {LaTeX -> "Q^c"}},
       {FlL, {LaTeX -> "L"}},
       {FlR, {LaTeX -> "L^c"}},
       {FPhi, {LaTeX -> "\\Phi"}}
      



        };       


